<?php 
error_reporting(E_ALL);
ini_set('display_errors', 1);


function setResult($success, $message, $data=null){
    $result = array();
    $result['success'] = $success;
    $result['message'] = $message;

    if( !is_null($data) ){
        $result['data'] = $data;
    }

    return $result;
}

function generate_json($result){

    function is_valid_callback($subject){
        $identifier_syntax
          = '/^[$_\p{L}][$_\p{L}\p{Mn}\p{Mc}\p{Nd}\p{Pc}\x{200C}\x{200D}]*+$/u';

        $reserved_words = array('break', 'do', 'instanceof', 'typeof', 'case',
          'else', 'new', 'var', 'catch', 'finally', 'return', 'void', 'continue', 
          'for', 'switch', 'while', 'debugger', 'function', 'this', 'with', 
          'default', 'if', 'throw', 'delete', 'in', 'try', 'class', 'enum', 
          'extends', 'super', 'const', 'export', 'import', 'implements', 'let', 
          'private', 'public', 'yield', 'interface', 'package', 'protected', 
          'static', 'null', 'true', 'false');

        return preg_match($identifier_syntax, $subject)
            && ! in_array(mb_strtolower($subject, 'UTF-8'), $reserved_words);
    }

    function header_json($noCache=true){
        if( $noCache ){
            header('Cache-Control: no-cache, must-revalidate');
            header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
        }
        header('Content-type: application/json; charset=UTF-8');
    }

    $json = json_encode($result);

    # JSON if no callback
    if( ! isset($_GET['callback'])){
        header_json();
        exit($json);
    }

    # JSONP if valid callback
    if(is_valid_callback($_GET['callback'])){
        header_json();
        exit("{$_GET['callback']}($json)");
    }

    # Otherwise, bad request
    header('status: 400 Bad Request', true, 400);
    exit();
}

date_default_timezone_set('America/Lima');

/* Set a liberal script execution time limit */
if (function_exists("set_time_limit") == TRUE AND @ini_GET("safe_mode") == 0){
    @set_time_limit(300);
}

if( !isset($_GET['action']) && !isset($_POST['action']) && !isset($_GET['_s']) ){
    generate_json(setResult(false, 'bad option.'));
}

//### SESSION ###
    // Allow cookies in IE?
    header('P3P:CP="IDC DSP COR ADM DEVi TAIi PSA PSD IVAi IVDi CONi HIS OUR IND CNT"');
    @session_start();
    //session_id();


    function token_exists(){
        return isset($_SESSION['token']);
    }
    function token_new(){
        return $_SESSION['token'] = md5(uniqid(rand(), true));
    }
    if( !token_exists() ){
        token_new();
    }
//### /SESSION ###

//### IP ###
    $ip = '';
    if ( !empty($_SERVER['HTTP_CLIENT_IP']) ){
        $ip = $_SERVER['HTTP_CLIENT_IP'];
    } elseif ( !empty($_SERVER['HTTP_X_FORWARDED_FOR']) ){
        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    } else {
        $ip = $_SERVER['REMOTE_ADDR'];
    }
//### /IP ###

//### TIME ###
    $current_datetime = date( 'Y-m-d H:i:s', time());
//### /TIME ###

//### GEOIP ###

  function getPath($path){
    if( substr($path, 0, 1) != DIRECTORY_SEPARATOR ){
      $path = DIRECTORY_SEPARATOR . $path;
    }
    return realpath($_SERVER['DOCUMENT_ROOT'] . $path);
  }

  $mmdbFile = 'GeoLite2-City.mmdb';
  $mmdbPath = 'vendor/geoip2/geoip2/maxmind-db/';

  require_once getPath('vendor/autoload.php');
  use GeoIp2\Database\Reader;

  $reader = new Reader( getPath($mmdbPath . $mmdbFile) );
  $ipList = array();

  function getLocationFromIP($ip){
    global $reader, $ipList;

    if( !array_key_exists($ip, $ipList) ){
      $lang = 'es';
      $record = $reader->city($ip);
      $ipList[$ip] = array(
        'city'     => '',
        'country'  => '',
        'toString' => ''
      );

      if( $record ){
        if( !is_null($record->country->name) ){
          if( isset($record->country->names[$lang]) ){
            $ipList[$ip]['country'] = $record->country->names[$lang];
          } else {
            $ipList[$ip]['country'] = $record->country->name;
          }
          $ipList[$ip]['toString'] = $ipList[$ip]['country'];

          if( !is_null($record->city->name) ){
            if( isset($record->city->names[$lang]) ){
              $ipList[$ip]['city'] = $record->city->names[$lang];
              $ipList[$ip]['toString'] = $record->city->names[$lang] . ', ' . $ipList[$ip]['toString'];
            } else {
              $ipList[$ip]['city'] = $record->city->name;
              $ipList[$ip]['toString'] = $record->city->name . ', ' . $ipList[$ip]['toString'];
            }
          }
        }
      }
    }

    return $ipList[$ip];
  }
//### /GEOIP ###

require 'inc/facebook-php-sdk/facebook.php';

function getProfilePictureURL($uid){
    $headers = get_headers('https://graph.facebook.com/' . $uid . '/picture', 1);
    return (isset($headers['Location']) ? $headers['Location'] : false);
}
    
/*
    $facebook = new Facebook(array(
      'appId'  => '836658126365417',
      'secret' => '5329b9cab603c0376bf5c413aa4cbd33',
    ));

    // Get User ID
    $user = $facebook->getUser();

    if ($user) {
      try {
        // Proceed knowing you have a logged in user who's authenticated.
        $user_profile = $facebook->api('/me?fields=name,birthday,email,gender');
        if (empty($user_profile['name'])) {
            $user_profile['name'] = '[sin nombre]';
        }

      } catch (FacebookApiException $e) {

        //echo '<pre>'.htmlspecialchars(print_r($e, true)).'</pre>';
        $user = null;
      }
    }

    if(!$user){
        generate_json(setResult(false, 'No iniciado.', array('user'=>$user)));
    }
*/

// ###  ###

//### DATABASE ###
    require 'inc/mysqliwrapper.php';
    $db = new mysqliWrapper(array(
        'hostname' => 'mysql51-085.wc1.ord1.stabletransit.com',
        'database' => '899794_monstruo2014',
        'username' => '899794_leapgs',
        'password' => 'd#5DG@4ce',
        'charset'  => 'utf8'
    ));
//### /DATABASE ###

if( isset($_GET['action']) ){
    switch($_GET['action']):
        case 'user:get':
            $result_user = $db->q('SELECT id, uid, name, DATE_FORMAT(FROM_DAYS(DATEDIFF(CURDATE(), birthday)), "%Y")+0 AS age, gender FROM users WHERE uid = ?', 's', $user_profile['id']);
            if( count($result_user) ){
                $result_scores = $db->q('SELECT game, MAX(score) as score FROM users_playing WHERE user_id = ? GROUP BY game', 'i', $result_user[0]['id']);
                
                $scores = array();
                foreach($result_scores as $row){
                    $scores[$row['game']] = $row['score'];
                }
                
                //evitamos que salga el ID del usuario
                unset($result_user[0]['id']); 

                //obtenemos la foto de perfil
                $result_user[0]['profilePictureURL'] = getProfilePictureURL($result_user[0]['uid']);


                $result_user[0]['scores'] = $scores;
                generate_json(setResult(true, '', $result_user[0]));
            } else {
                generate_json(setResult(false, ''));
            }
        break;
        case 'user:check':
            //$result = $db->q('SELECT * FROM users WHERE uid = ?', 's', $user_profile['id']);
            $result = $db->q('SELECT * FROM users WHERE email = ?', 's', $_GET['email']);

            if( count($result) ){
                if( $result[0]['uid'] == ''){
                    $db->q('UPDATE users SET uid=? WHERE email=?', 'ss', array(
                        'uid' => $_GET['fbid'],
                        'email' => $_GET['email']
                    ));
                }

                $_SESSION['user_id'] = $result[0]['id'];
                $_SESSION['blocked'] = $result[0]['blocked'];


                generate_json(setResult(true, '', array(
                    'register' => true,
                    'score' => (is_null($result[0]['score']) ? 0 : $result[0]['score'])
                )));
            } else {
                generate_json(setResult(true, '', array(
                    'register' => false,
                    'score' => 0
                )));
            }
        break;
        case 'user:register':
            //$user_profile['birthday'] = ''; // Demo sin birthday
            $__res = array(
                'userId' => 0
            );

            $result = $db->q('SELECT * FROM users WHERE uid = ?', 's', $user_profile['id']);

            if( count($result) > 0 ){
                // SE ENCUENTRA REGISTRADO
                $__res['userId'] = $result[0]['id'];
            } else {
                // INTENTARA REGISTRAR AL USUARIO SI CUENTA CON BIRTHDAY
                $birthday = '';
                if( empty($user_profile['birthday']) ){
                    if( isset($_GET['birthday_year'], $_GET['birthday_month'], $_GET['birthday_date']) ){
                        // SI LE PASO EL BIRTHDAY POR "GET"
                        $birthday = $_GET['birthday_year'] .'-'. $_GET['birthday_month'] .'-'. $_GET['birthday_date'];
                    }
                } else {
                    // SI TIENE CONFIGURADO SU BIRTHDAY EN SU CUENTA DE FACEBOOK
                    list($month, $date, $year) = explode('/', $user_profile['birthday']);
                    $birthday = $year .'-'. $month .'-'. $date;
                }

                if( !empty($birthday) ){
                    // REGISTRA EN BD
                    $db->q('INSERT INTO users (uid, name, birthday, gender, email, created_at) VALUES (?,?,?,?,?,?)','ssssss',
                        $user_profile['id'],
                        $user_profile['name'],
                        $birthday,
                        substr($user_profile['gender'],0,1),
                        $user_profile['email'],
                        $current_datetime
                    );

                    $userId = $db->insert_id();
                    if( $userId ){
                        $__res['userId'] = $userId;
                    }
                }
            }

            generate_json(setResult(true, '', $__res));
        break;
        case 'user:session':
            //session_unset();
            //session_destroy();

            $__res = array(
                'session' => ''
            );

            if(isset($_SESSION['email'])) {
                $__res = array(
                    'session' => $_SESSION['type']
                );
            }

            generate_json(setResult(true, '', $__res));
        break;
        /*
        case 'score:save':
            $_score = (int)$_GET['score'];
                
            // SAVE in DB
            $result = $db->q('SELECT * FROM users WHERE uid = ?', 's', $user_profile['id']);
            $user = $result[0];

            $result = $db->q('SELECT * FROM users_playing WHERE user_id = ?', 'i', $user['id']);
            $user_played = (count($result) > 0);

            $result = $db->q(''.
                'INSERT INTO users_playing (user_id, ip, game, score, created_at) VALUES (?,?,?,?,?)','issis',
                $user['id'],
                $ip,
                $_GET['game'],
                $_score,
                $current_datetime
            );

            // SAVE in Facebook
            //$facebook->api('/me/scores', 'post', array('score'=>$_score));

            if( !$user_played ):
                if( $user['id'] == 415 ){
                    $messages = array(
                        'Soy tan malo que obtuve '. $_score .' =( .',
                        'Soy tan malo que obtuve '. $_score .' =( .'
                    );
                } else {
                    $messages = array(
                        '- Obtuve '. $_score .' puntos jugando en Panas F.C. ¿Crees tener un mejor equipo de panas que el mío? Demuéstralo.',
                        '- El fútbol solo se disfruta cuando juntas a tus panas y a KFC. Yo ya los reuní y obtuve '. $_score .' puntos.'
                    );
                }
                // Post in Facebook
                $facebook->api('/me/feed', 'POST', array(
                    //'message'=>'msg'
                    'link'       => 'http://panasfutbolclub.com',
                    'picture'    => 'http://panasfutbolclub.com/assets/share.jpg',
                    'name'       => 'Panas Futbol Club',
                    'caption'    => '',
                    'description'=> $messages[ rand(0,1) ]
                ));
            endif;

            
            //$result = $db->q(
            //  'UPDATE users SET score = ? WHERE id = ?', 'ss', 
            //  $score,
            //  $this->user_id
            //);
            
            generate_json(setResult(true, 'Funciona!', array('result'=>$result) ));
        break;
        */
        case 'score:global':
            $result_user = $db->q('SELECT *, DATE_FORMAT(FROM_DAYS(DATEDIFF(CURDATE(), birthday)), "%Y")+0 AS age FROM users WHERE uid = ?', 's', $user_profile['id']); 

            $filter_by_age = ' AND (DATE_FORMAT(FROM_DAYS(DATEDIFF(CURDATE(), u.birthday)), "%Y")+0) '. ($result_user[0]['age'] >= 18 ? '>=' : '<' ) .' 18 ';

            $subsql = ' SELECT f.*, @rownum := @rownum + 1 AS rank FROM ('.
                'SELECT u.id, u.uid, u.name, MAX(t.score) as score_max '.
                'FROM users_playing t INNER JOIN users u ON t.user_id = u.id '.
                'WHERE t.game = ? AND u.blocked = 0 '. $filter_by_age .
                'GROUP BY u.id, u.uid, u.name '.
                'ORDER BY MAX(t.score) DESC '.
            ') f, (SELECT @rownum := 0) r ';
            $result = $db->q($subsql, 's', $_GET['game']);
            $total = count($result);

            if( $total == 0 ){
                generate_json(setResult(true, '', []));
            }


            

            $sql = ''.
                'SELECT rank FROM ('. $subsql .') ranking '.
                'WHERE id=? '.
                'GROUP BY rank '.
                'LIMIT 1';

            $result = $db->q($sql,
                'si',
                $_GET['game'],
                $result_user[0]['id']
            );

            $rank = ( count($result) ? $result[0]['rank'] : 1 );
            

            


            // TOP
            $rank_start = 1;
            $rank_end = 5;

            if( $rank >= 3 ){

                // MIDDLE
                $rank_start = $rank - 2;
                $rank_end = $rank + 2;

                if( $rank_end > $total ){

                    // BOTTOM
                    $rank_start = max($total - 4, 1);
                    $rank_end = $total;
                }
            }
            
            

            $sql = ''.
                'SELECT score_max as score, uid, name, rank from ('. $subsql .') ranking '.
                'WHERE rank BETWEEN '. $rank_start .' AND '. $rank_end . ' '.
                'ORDER BY rank ';

            $result = $db->q($sql, 's', $_GET['game']);
            
            if( count($result) > 0 ){

                foreach($result as $index => $row){
                    $result[$index]['profilePictureURL'] = getProfilePictureURL( $row['uid'] );
                }

                generate_json(setResult(true, '', $result));
                
                /*
                generate_json(setResult(true, '', array(
                    'result'=>$result,
                    'sql2'=>$sql,
                    'start' => $rank_start,
                    'end' => $rank_end,
                    'rank' => $rank
                )));
                */
            }

            generate_json(setResult(false, ''));
            
            break;
        break;
    endswitch;
} else {
    if( isset($_POST['action']) ){
        switch($_POST['action']):
            case 'user:login':
                $__res = array(
                    'status' => 'NOT FOUND',
                    'score' => 0
                );

                $result = $db->q('SELECT email, passwd, score FROM users WHERE email = ?', 's', $_POST['email']);
                if(count($result) > 0) {
                    if($result[0]['passwd'] == $_POST['password']){
                        $__res['status'] = 'FOUND';
                        $__res['score'] = (is_null($result[0]['score']) ? 0 : $result[0]['score']);

                        $_SESSION['email'] = $result[0]['email'];
                    }
                }

                generate_json(setResult(true, '', $__res));
            break;
            case 'score:save':
                $_score = (int)$_POST['score'];

                $location = getLocationFromIP($ip);

	            // SAVE in DB
	            $result = $db->q('SELECT * FROM users WHERE email = ?', 's', $_SESSION['email']);
	            $user = $result[0];

	            $result = $db->q(''.
	                'INSERT INTO users_playing (user_id, ip, city, country, score, created_at) VALUES (?,?,?,?,?,?)', 'isssis',
	                $user['id'],
	                $ip,
	                $location['city'],
	                $location['country'],
	                $_score,
	                $current_datetime
	            );

	            $result = $db->q('SELECT MAX(score) FROM users_playing WHERE user_id = ?', 'i', $user['id']);
	            $result = $db->q('UPDATE users SET score = ?, city = ?, country = ?, ip = ? WHERE user_id = ?', 'isssi', 
	                $result[0]['score'], 
	                $result[0]['city'], 
	                $result[0]['country'], 
	                $result[0]['ip'],
	                $user['id']
	            );

	            generate_json(setResult(true, 'Funciona!', array('result'=>1) ));
                
                /*
                $messages = array(
                    'Obtuve '. $_score .' puntos jugando en Panas F.C. ¿Crees tener un mejor equipo de panas que el mío? Demuéstralo.',
                    'El fútbol solo se disfruta cuando juntas a tus panas y a KFC. Yo ya los reuní y obtuve '. $_score .' puntos.'
                );

                // Post in Facebook
                $facebook->api('/me/feed', 'POST', array(
                    //'message'=>'msg'
                    'link'       => 'http://panasfutbolclub.com',
                    'picture'    => 'http://panasfutbolclub.com/assets/share.jpg',
                    'name'       => 'Panas Futbol Club',
                    'caption'    => '',
                    'description'=> $messages[ rand(0,1) ]
                ));
                */

			

                /*
                $result = $db->q(
                    'UPDATE users SET score = ? WHERE id = ?', 'ss', 
                    $score,
                    $this->user_id
                );
                */
                //generate_json(setResult(true, 'Funciona!', array('result'=>1) ));
            break;
            case 'user:register':
                //$user_profile['birthday'] = ''; // Demo sin birthday
                $__res = array(
                    'status' => 'ERROR',
                    'userId' => 0
                );

                $result = $db->q('SELECT * FROM users WHERE email = ?', 's', $_POST['email']);

                if( count($result) > 0 ){
                    // SE ENCUENTRA REGISTRADO
                    $__res['status'] = 'FOUND';
                    $__res['userId'] = $result[0]['id'];
                } else {
                    // INTENTARA REGISTRAR AL USUARIO SI CUENTA CON BIRTHDAY
                    $birthday = '';

                    if( !empty($_POST['birthday']) ){
                        list($birthday_date, $birthday_month, $birthday_year) = explode('/', $_POST['birthday']);
                        $birthday = $birthday_year .'-'. $birthday_month .'-'. $birthday_date;
                    }

                    if( !empty($birthday) ){
                        // REGISTRA EN BD
                        $db->q('INSERT INTO users (uid, name, birthday, gender, email, passwd, cedula, created_at) VALUES (?,?,?,?,?,?,?,?)','ssssssss',
                            isset($_POST['fbid']) ? $_POST['fbid'] : '',
                            $_POST['name'],
                            $birthday,
                            substr($_POST['gender'], 0, 1),
                            $_POST['email'],
                            isset($_POST['password']) ? $_POST['password'] : '',
                            $_POST['cedula'],
                            $current_datetime
                        );

                        $_SESSION['email'] = $_POST['email'];

                        $userId = $db->insert_id();
                        if( $userId ){
                            $__res['_error'] = 4;
                            $__res['status'] = 'REGISTERED';
                            $__res['userId'] = $userId;
                        }
                    }
                }

                generate_json(setResult(true, '', $__res));
            break;
        endswitch;
    }
    
    if( isset($_GET['_s']) ){
        //list($_score, $_game) = explode('|', base64_decode($_POST['_s']));

        $postdata = file_get_contents("php://input");
        if( !empty($postdata) && !ctype_print($postdata) ){
            $binarydata = gzuncompress($postdata);
            //$data = unpack("Nscore/Ngame", $binarydata);
            $data = unpack("Nscore", $binarydata);
            
            $_score = $data['score'];
            //$_game  = $data['game'];
            //$_game  = 1;

            //$result = $db->q('SELECT * FROM users WHERE email = ?', 's', $_SESSION['email']);
            //$user = $result[0];

            //$result = $db->q('SELECT * FROM users_playing WHERE user_id = ?', 'i', $user['id']);
            //$user_played = (count($result) > 0);

            /*
            if( !$user_played ):
                // POST FEED in Facebook
                $messages = array(
                    'Obtuve '. $_score .' puntos jugando en Panas F.C. ¿Crees tener un mejor equipo de panas que el mío? Demuéstralo.',
                    'El fútbol solo se disfruta cuando juntas a tus panas y a KFC. Yo ya los reuní y obtuve '. $_score .' puntos.'
                );
                $facebook->api('/me/feed', 'POST', array(
                    'link'       => 'http://panasfutbolclub.com',
                    'picture'    => 'http://panasfutbolclub.com/assets/share.jpg',
                    'name'       => 'Panas Futbol Club',
                    'caption'    => '',
                    'description'=> $messages[ rand(0,1) ]
                ));
            endif;
            */
            
            // SAVE in Facebook
            //$facebook->api('/me/scores', 'post', array('score'=>$_score));
            
            $location = getLocationFromIP($ip);

            // SAVE in DB
            $result = $db->q('SELECT * FROM users WHERE email = ?', 's', $_SESSION['email']);
            $user = $result[0];

            $result = $db->q(''.
                'INSERT INTO users_playing (user_id, ip, city, country, score, created_at) VALUES (?,?,?,?,?,?)', 'isssis',
                $user['id'],
                $ip,
                $location['city'],
                $location['country'],
                $_score,
                $current_datetime
            );

            $result = $db->q('SELECT MAX(score) FROM users_playing WHERE user_id = ?', 'i', $user['id']);
            $result = $db->q('UPDATE users SET score = ?, city = ?, country = ?, ip = ? WHERE user_id = ?', 'isssi', 
                $result[0]['score'], 
                $result[0]['city'], 
                $result[0]['country'], 
                $result[0]['ip'],
                $user['id']
            );

            generate_json(setResult(true, 'Funciona!', array('result'=>1) ));
        }
    }
}



generate_json(setResult(false, '._.'));
?>
